<?php

namespace App\DataTables;

use App\Models\Fornitore;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class FornitoreDataTableEditor extends DataTablesEditor
{
  protected $model = Fornitore::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'email.required' => 'L\'email è richiesta',
    'telefono.required' => 'Il telefono è richiesto',
    'indirizzo.required' => 'L\'indirizzo è richiesto',
    'citta.required' => 'La città è richiesta',
    'provincia.required' => 'La provincia è richiesta',
    'cap.required' => 'Il CAP è richiesto',
    'paese.required' => 'Il paese è richiesto',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => 'required',
      'email' => 'required|email',
      // 'telefono' => 'required',
      // 'indirizzo' => 'required',
      // 'citta' => 'required',
      // 'provincia' => 'required',
      // 'cap' => 'required',
      // 'paese' => 'required',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome'  => 'required',
      'email' => 'nullable|email',
      'telefono' => 'nullable',
      'indirizzo' => 'required',
      'citta' => 'nullable',
      'provincia' => 'nullable',
      'cap' => 'nullable',
      'paese' => 'nullable',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
